#ifndef MIE_ETAT_ETAT_IMPL_H_
#define MIE_ETAT_ETAT_IMPL_H_

using namespace Xbyak;

class GeneratorForF3_97 : public Xbyak::CodeGenerator {
public:
	GeneratorForF3_97()
		: CodeGenerator(1024 * 16)
	{
	}
	void createOptimizedMulLatter(int bit, int w)
	{
		const int sep = 32 / w;
		const int topBit = ((w - 1) / bit) * bit;
		const int firstShiftBit = w - topBit < bit ? w - topBit : bit;
		const int loop = (w + bit - 1) / bit;
		const int idxTblSize = loop * 4 * 4 + 16;
		push(esi);
		const int P_ = 4 * 1;

		mov(edx, ptr [esp + P_ + 8]); // xTbl
		mov(ecx, ptr [esp + P_ + 12]); // b
		sub(esp, idxTblSize);
		mov(esi, esp);
		and(esi, uint32_t(~15)); // idxTbl

		/* w = 8, b = 4̂Ƃ45clkx */
		makeIdxTbl(bit, w, firstShiftBit, topBit, ecx, esi);

		const Xmm* L0(&xm0);
		const Xmm* L1(&xm1);
		const Xmm* H0(&xm2);
		const Xmm* H1(&xm3);
		mov(eax, ptr [ecx + 16 + 12]); // b.get(m - 1).high
#ifdef QQQ
		shl(eax, bit);
#else
		add(eax, eax);
#endif
		add(eax, ptr [ecx + 12]); // b.get(m - 1).low
		shl(eax, 2);
		movdqa(*L0, ptr [edx + eax * 8]);
		movdqa(*H0, ptr [edx + eax * 8 + 16]);
		/* x << (96 - w + firstShiftBit) for x = [0:L0], [0:H0], w = 8, 16, 32 */
		const int sb = (96 - w) / 8;
		pxor(*L1, *L1);
		pxor(*H1, *H1);
		pxor(xm4, xm4);
		pxor(xm5, xm5);
		palignr(*L1, *L0, 15 - sb);
		palignr(*H1, *H0, 15 - sb);
		palignr(xm4, *L0, 16 - sb);
		palignr(xm5, *H0, 16 - sb);
		psrlq(*L1, 8 - firstShiftBit);
		psrlq(*H1, 8 - firstShiftBit);
		psllq(xm4, firstShiftBit);
		psllq(xm5, firstShiftBit);
		pslldq(*L0, sb);
		pslldq(*H0, sb);
		por(*L1, xm4);
		por(*H1, xm5);
		psllq(*L0, firstShiftBit);
		psllq(*H0, firstShiftBit);

		const Xmm* t0(&xm4);
		const Xmm* t1(&xm5);

		for (int i = 0; i < loop; i++) {
			movzx(eax, byte [esi]);
			shl(eax, 2);
			movdqa(*t0, ptr [edx + eax * 8]); // xTbl[i][0]
			movdqa(*t1, ptr [edx + eax * 8 + 16]);
#ifdef MIE_USE_6OP_ADD
			add16DD(*L0, *H0, *t0, *t1);
			std::swap(L0, t1); std::swap(H0, t0);
#else
			add16D(*L0, *H0, *t0, *t1, xm6);
#endif

			int u = w / 8;
			for (int j = 1; j < sep * 3; j++) {
				movzx(eax, byte [esi + j * (w / 8)]);
				shl(eax, 2);
				ror256X(*L0, *L1, xm6, u); std::swap(L0, L1);
				ror256X(*H0, *H1, xm7, u); std::swap(H0, H1);
				movdqa(*t0, ptr [edx + eax * 8]); // xTbl[i][1]
				movdqa(*t1, ptr [edx + eax * 8 + 16]);
#ifdef MIE_USE_6OP_ADD
				add16DD(*L0, *H0, *t0, *t1);
				std::swap(L0, t1); std::swap(H0, t0);
#else
				add16D(*L0, *H0, *t0, *t1, xm6);
#endif
			}

			rol256(*L0, *L1, xm6, 12 - u);
			rol256(*H0, *H1, xm7, 12 - u);
			if (i < loop - 1) {
				shlBit(*L0, *L1, xm6, bit);
				shlBit(*H0, *H1, xm7, bit);
				add(esi, 16);
			}
		}
		reduce(*L0, *L1, *H0, *H1, *t0, *t1, xm6);

		add(esp, idxTblSize);
		mov(eax, ptr [esp + P_ + 4]); // out

		movdqa(ptr [eax + 0], *L0);
		movdqa(ptr [eax + 16], *H0);

		pop(esi);
		ret();
	}
	void createOptimizedMakePrevMulTbl(int bit)
	{
		mov(eax, ptr [esp + 4]); // xTbl
		mov(edx, ptr [esp + 8]); // x

		movdqa(xm0, ptr [edx]); // xL
		movdqa(xm1, ptr [edx + 16]); // xH

#ifdef QQQ
		pxor(xm2, xm2);
		setTbl(0, xm2, xm2); // 0
		setTbl(1, xm0, xm1); // x
		setTbl(1 << bit, xm1, xm0); // -[H:L] = [L:H]
		if (bit > 1) {
			shlBit(xm0, xm1, xm2, 1);
			setTbl(2, xm0, xm1);
			movdqa(xm5, ptr [eax + 3 * 32]);
			movdqa(xm7, xm5);
			movdqa(xm6, ptr [eax + 3 * 32 + 16]);
			setTbl(6, xm6, xm5); // -[3]
			por(xm7, xm6);
			add0(4, 1, xm5, xm6, xm0, xm1, xm2, xm7);
			add0(5, 2, xm5, xm6, xm0, xm1, xm2, xm7);
		}
		for (int b = 2; b < bit; b++) {
			makeTbl(b);
		}
#else
		pxor(xm2, xm2);
		setTbl(0, xm2, xm2); // 0
		setTbl(1, xm0, xm1); // a
		setTbl(2, xm1, xm0); // -[H:L] = [L:H]
		if (bit > 1) {
			movdqa(xm3, xm0);
			movdqa(xm4, xm1);
			shlBit(xm0, xm1, xm2, 1); // b = a << 1
			setTbl(3, xm0, xm1); // b
			setTbl(6, xm1, xm0); // -b
			movdqa(xm5, xm3);
			movdqa(xm6, xm4);
			movdqa(xm7, xm0);
			por(xm7, xm1); // hint
			add16hint(xm3, xm4, xm0, xm1, xm2, xm7); // a + b
			add16hint(xm6, xm5, xm0, xm1, xm2, xm7); // -a + b
			setTbl(4, xm3, xm4); // b + a
			setTbl(getNegIdx(4), xm4, xm3); // -(b + a)
			setTbl(5, xm6, xm5); // b - a
			setTbl(getNegIdx(5), xm5, xm6); // -(b - a)
		}
		for (int b = 2; b < bit; b++) {
			makeTbl(b);
		}
#endif
		ret();
	}
	void createOptimizedDegree()
	{
		mov(ecx, ptr [esp + 4]); // this
		mov(edx, ptr [ecx + 12]);
		or(edx, ptr [ecx + 16 + 12]);
		jnz("exit96");
		mov(edx, ptr [ecx + 8]);
		or(edx, ptr [ecx + 16 + 8]);
		jnz("exit64");
		mov(edx, ptr [ecx + 4]);
		or(edx, ptr [ecx + 16 + 4]);
		jnz("exit32");
		mov(edx, ptr [ecx]);
		or(edx, ptr [ecx + 16]);
		bsr(eax, edx);
		cmovz(eax, edx);
		ret();
	L("exit32");
		bsr(eax, edx);
		add(eax, 32);
		ret();
	L("exit64");
		bsr(eax, edx);
		add(eax, 64);
		ret();
	L("exit96");
		mov(eax, 96);
		ret();
	}
	void rawShl()
	{
		mov(eax, ptr [esp + 4]); // this
		mov(edx, ptr [esp + 8]); // bit
		movdqa(xm0, ptr [eax]); // L
		movdqa(xm1, ptr [eax + 16]); // H
		cmp(edx, 64);
		jb("bit_lt_64");
		pslldq(xm0, 8);
		pslldq(xm1, 8);
		sub(edx, 64);
	L("bit_lt_64");
		movd(xm6, edx); // bit
		neg(edx);
		add(edx, 64);
		movd(xm7, edx); // 64 - bit
		pxor(xm2, xm2);
		pxor(xm3, xm3);
		movlhps(xm2, xm0);
		movlhps(xm3, xm1);
		psllq(xm0, xm6);
		psllq(xm1, xm6);
		psrlq(xm2, xm7);
		psrlq(xm3, xm7);
		por(xm0, xm2);
		por(xm1, xm3);
		movdqa(ptr [eax], xm0);
		movdqa(ptr [eax + 16], xm1);
		ret();
	}
	void rawShl(int bit)
	{
		assert(0 < bit && bit < 64);
		mov(eax, ptr [esp + 4]); // this
		movdqa(xm0, ptr [eax]); // L
		movdqa(xm1, ptr [eax + 16]); // H
		pxor(xm2, xm2);
		pxor(xm3, xm3);
		movlhps(xm2, xm0);
		movlhps(xm3, xm1);
		psllq(xm0, bit);
		psllq(xm1, bit);
		psrlq(xm2, 64 - bit);
		psrlq(xm3, 64 - bit);
		por(xm0, xm2);
		por(xm1, xm3);
		movdqa(ptr [eax], xm0);
		movdqa(ptr [eax + 16], xm1);
		ret();
	}
	void createOptimizedRawShl(int type)
	{
		switch (type) {
		case 0:
			rawShl();
			break;
		case 1:
		case 2:
			rawShl(type);
			break;
		}
	}
	void createOptimizedCube()
	{
		push(esi);
		const int P_ = 4 * 1;
		mov(esi, ptr [esp + P_ + 4]); // x
		mov(ecx, (int)MIE_ETAT::cubeTbl);
		cubeCore(esi, 0, ecx, eax, edx);
		pop(esi);
		ret();
	}
	void createOptimizedCubeSeq()
	{
		const int m = 97;
		const int lpN = (m + 1) / 2;
		push(esi);
		push(edi);
		const int P_ = 4 * 2;
		mov(esi, ptr [esp + P_ + 4]); // x
		mov(ecx, (int)MIE_ETAT::cubeTbl);
		mov(edi, lpN - 1);
	L("lp");
		cubeCore(esi, 32, ecx, eax, edx);
		add(esi, 32);
		sub(edi, 1);
		jnz("lp");

		pop(edi);
		pop(esi);
		ret();
	}
private:
	uint8_t pack(uint32_t a, uint32_t b, uint32_t c, uint32_t d)
	{
		return static_cast<uint8_t>((a << 6) | (b << 4) | (c << 2) | d);
	}
	/*
		swap 1 and 2 for each bit
		ex.
		1102(3) -> 2201(3)
	*/
	uint32_t getNegIdx(uint32_t x)
	{
		uint32_t ret = 0;
		uint32_t i = 1;
		while (x > 0) {
			uint32_t r = x % 3;
			if (r) {
				ret += (3 - r) * i;
			}
			i *= 3;
			x /= 3;
		}
		return ret;
	}
	/*
		input : eax(xTbl), edx(x)
	*/
	void makeTbl(int b)
	{
		const int n = intpow3(b);
		movdqa(xm5, ptr [eax + (n / 3) * 32]);
		movdqa(xm6, ptr [eax + (n / 3) * 32 + 16]);
		shlBit(xm5, xm6, xm7, 1);
		setTbl(n, xm5, xm6);
		setTbl(getNegIdx(n), xm6, xm5);
		movdqa(xm7, xm5);
		por(xm7, xm6);
		for (int i = 0; i < n - 1; i++) {
			add0(i + n + 1, i + 1, xm5, xm6, xm0, xm1, xm2, xm7);
		}
	}
	/*
		[L:H] = ror_n([H:L])
	*/
	void ror256X(const Xmm& L, const Xmm& H, const Xmm& t, int nByte)
	{
		assert(nByte < 16);
		movdqa(t, H);
		palignr(H, L, nByte);
		palignr(L, t, nByte);
	}
	void rol256(const Xmm& L, const Xmm& H, const Xmm& t, int nByte)
	{
		assert(nByte < 16);
		movdqa(t, H);
		palignr(H, L, 16 - nByte);
		palignr(L, t, 16 - nByte);
	}
	static void printHex(const uint32_t *p, const char *msg, int len)
	{
		if (msg) printf("%s ", msg);
		for (int i = 0; i < len; i++) {
			printf("%08x:", p[len - 1 - i]);
		}
		printf("\n");
	}
	void debug(const Operand& x, const char *msg = 0)
	{
		push(eax);
		push(ecx);
		push(edx);

		MIE_ALIGN(16) static uint32_t buf[4];
		if (x.isREG(32)) {
			mov(ptr [buf], x);
			push(1);
		} else if (x.isXMM()) {
			movdqa(ptr [buf], static_cast<const Xmm&>(x));
			push(4);
		} else {
			assert(1);
		}
		push((int)(msg ? msg : x.toString())); // msg
		push((int)buf); // p
		call((void*)printHex);
		add(esp, 12);

		pop(edx);
		pop(ecx);
		pop(eax);
	}
	/*
		x = expand(reg) << shift
		input reg, tbl
		output : x
		destroy : reg
	*/
	void expand(const Xmm& x, const Reg32& reg, const Reg32& tbl, const Xmm& tx, const Reg32& tr, int shift)
	{
		const uint32_t m10 = GetMask(10);
		const uint32_t m11 = GetMask(11);
		switch (shift) {
		case 0:
			mov(tr, reg);
			and(tr, m11);
			movd(x, ptr [tbl + tr * 4]);
			mov(tr, reg);
			shr(tr, 11);
			and(tr, m11);
			movd(tx, ptr [tbl + tr * 4]);
			psllq(tx, 33);
			shr(reg, 22);
			por(x, tx);
			movd(tx, ptr [tbl + reg * 4]);
			psllq(tx, 2);
			movlhps(x, tx);
			break;
		case 1:
			mov(tr, reg);
			and(tr, m11);
			movd(x, ptr [tbl + tr * 4]);
			mov(tr, reg);
			shr(tr, 11);
			and(tr, m10);
			paddd(x, x);
			movd(tx, ptr [tbl + tr * 4]);
			psllq(tx, 34);
			shr(reg, 21);
			por(x, tx);
			movd(tx, ptr [tbl + reg * 4]);
			movlhps(x, tx);
			break;
		case 2:
			mov(tr, reg);
			and(tr, m10);
			movd(x, ptr [tbl + tr * 4]);
			psllq(x, 2);
			mov(tr, reg);
			shr(tr, 10);
			and(tr, m11);
			movd(tx, ptr [tbl + tr * 4]);
			psllq(tx, 32);
			por(x, tx);
			shr(reg, 21);
			movd(tx, ptr [tbl + reg * 4]);
			paddd(tx, tx);
			movlhps(x, tx);
			break;
		}
	}
	/*
		x = t >> bit
	*/
	void shr128(const Xmm& x, const Xmm& t, int bit)
	{
		movdqa(t, x);
		psrldq(t, 8);
		psrlq(x, bit);
		psllq(t, 64 - bit);
		por(x, t);
	}
	/*
		x = t << bit
	*/
	void shl128(const Xmm& x, const Xmm& t, int bit)
	{
		movdqa(t, x);
		pslldq(t, 8);
		psllq(x, bit);
		psrlq(t, 64 - bit);
		por(x, t);
	}
	/*
		input : eax(xTbl)
		[eax + pos * 16] = L;
		[eax + pos * 16 + 16] = H;
		@note for only makePrevMulTbl
	*/
	void setTbl(int pos, const Xmm& L, const Xmm& H)
	{
		movdqa(ptr [eax + pos * 32], L);
		movdqa(ptr [eax + pos * 32 + 16], H);
	}
	/*
		input : eax(xTbl), [H:L], hint = L | H
		destroy : xm0, xm1, xm2
		xTbl[d] = xTbl[a] + [H:L]
		xTbl[getNegIdx(d)] = -xTbl[d]
		@note for only makePrevMulTbl
	*/
	void add0(int d, int a, const Xmm& L, const Xmm& H, const Xmm& t0, const Xmm& t1, const Xmm& t2, const Xmm& hint)
	{
		movdqa(t0, ptr [eax + a * 32]);
		movdqa(t1, ptr [eax + a * 32 + 16]);
		add16hint(t0, t1, L, H, t2, hint);
		setTbl(d, t0, t1); // +
		setTbl(getNegIdx(d), t1, t0); // -
	}
	/*
		input : eax(xTbl)
		xTbl[d] = -xTbl[a];
		@note for only makePrevMulTbl
	*/
	void neg0(int d, int a)
	{
		movdqa(xm0, ptr [eax + a * 32]);
		movdqa(xm1, ptr [eax + a * 32 + 16]);
		movdqa(ptr [eax + d * 32], xm1);
		movdqa(ptr [eax + d * 32 + 16], xm0);
	}
	/*
		input : [aH:aL], [bH:bL]
		destroy : t0, t1
		output : [aH:aL] += [bH:bL]
	*/
	void add16(const Xmm& aL, const Xmm& aH, const Xmm& bL, const Xmm& bH, const Xmm& t0, const Xmm& t1)
	{
		movdqa(t0, aL);
		movdqa(t1, bL);
		por(t0, aH);
		por(t1, bH);
		pand(t0, t1);
		por(aL, bL);
		por(aH, bH);
		pxor(aL, t0);
		pxor(aH, t0);
	}
	/*
		input : [aH:aL], [bH:bL]
		destroy : t, bL
		output : [aH:aL] += [bH:bL]
	*/
	void add16D(const Xmm& aL, const Xmm& aH, const Xmm& bL, const Xmm& bH, const Xmm& t)
	{
		movdqa(t, aL);
		por(aL, bL);
		por(t, aH);
		por(bL, bH);
		por(aH, bH);
		pand(t, bL);
		pxor(aL, t);
		pxor(aH, t);
	}
#ifdef MIE_USE_6OP_ADD
	/*
		input : [aH:aL], [bH:bL]
		destroy : aH, aL
		output : [bL:bH] <- [aH:aL] + [bH:bL]
	*/
	void add16DD(const Xmm& aL, const Xmm& aH, const Xmm& bL, const Xmm& bH)
	{
		pxor(bL, aL);
		pxor(bH, aH);
		pxor(aL, bH);
		pxor(aH, bL);
		pandn(bH, aH);
		pandn(bL, aL);
//		movdqa(aL, bH);
//		movdqa(aH, bL);
	}
#endif
	/*
		input : [dH:dL], [sH:sL], h = sL | sH
		destroy : t0, t1
		output : [dH:dL] += [sH:sL]
	*/
	void add16hint(const Xmm& aL, const Xmm& aH, const Xmm& bL, const Xmm& bH, const Xmm& t, const Xmm& hint)
	{
		movdqa(t, aL);
		por(t, aH);
		pand(t, hint);
		por(aL, bL);
		por(aH, bH);
		pxor(aL, t);
		pxor(aH, t);
	}
	/*
		input : [aH:aL], [bH:bL]
		destroy : t0, t1
		output : [aH:aL] -= [bH:bL]
	*/
	void sub16(const Xmm& aL, const Xmm& aH, const Xmm& bL, const Xmm& bH, const Xmm& t0, const Xmm& t1)
	{
		add16(aL, aH, bH, bL, t0, t1);
	}
	/*
		input : [H:L]
		output : [H:L] <<= byte
		cf.
		palignr(xm1, xm0, 15);
		[xm1:xm0] = [AABBCCDD6677889922334455EEFF0011:DDEEFF0099AABBCC5566778811223344]
		[xm1:xm0] = [BBCCDD6677889922334455EEFF0011DD:DDEEFF0099AABBCC5566778811223344]
		palignr(A, B, 1);
		[AAAAAAAAAAAAAAAA] -> [ABBBBBBBBBBBBBBBB]
	*/
	void shlByte(const Xmm& L, const Xmm& H, int nByte)
	{
		assert(nByte < 16);
		palignr(H, L, 16 - nByte);
		pslldq(L, nByte);
	}
	/*
		input : [H:L]
		destroy : t
		[H:L] <<= bit
	*/
	void shlBit(const Xmm& L, const Xmm& H, const Xmm& t, int nBit)
	{
		assert(nBit < 8);
		movdqa(t, H);
		palignr(t, L, 15);
		psllq(H, nBit);
		psrlq(t, 8 - nBit);
		por(H, t);
		movdqa(t, L);
		pslldq(t, 1);
		psllq(L, nBit);
		psrlq(t, 8 - nBit);
		por(L, t);
	}
	/*
		input : [H:L]
		destroy : t
		[H:L] >>= bit
	*/
	void shrBit(const Xmm& L, const Xmm& H, const Xmm& t, int nBit)
	{
		const int r = nBit / 8;
		const int q = nBit & 7;
		movdqa(t, L);
		palignr(L, H, r);
		palignr(t, H, r + 1);
		psrlq(L, q);
		psllq(t, 8 - q);
		por(L, t);
		shrBit(H, t, nBit);
	}
	/*
		input : x
		destroy : t
		x >>= bit
	*/
	void shrBit(const Xmm& x, const Xmm& t, int nBit)
	{
		const int r = nBit / 8;
		const int q = nBit & 7;
		psrldq(x, r);
		movdqa(t, x);
		psrlq(x, q);
		psrldq(t, 1);
		psllq(t, 8 - q);
		por(x, t);
	}
	// [193..0] = [96..0] + [193..97] + rol_12([193..97]) + ([193..182] << 12)
	/*
		input : [H:L]
		output out = H = ([H:L] >> 97), L : not change
		palignr(xm1, xm0, 15);
		[xm1:xm0] = [AABBCCDD6677889922334455EEFF0011:DDEEFF0099AABBCC5566778811223344]
		[xm1:xm0] = [BBCCDD6677889922334455EEFF0011DD:DDEEFF0099AABBCC5566778811223344]
	*/
	void shr97(const Xmm& L, const Xmm& H, const Xmm& t)
	{
		movdqa(t, H);
		// out = [H3:H2:H1:H0] L = [L3:L2:L1:L0] => [H2:H1:H0:L3]
		palignr(t, L, 12);
		palignr(H, L, 13);
		psrlq(t, 1);
		psllq(H, 8 - 1);
		por(H, t);
	}
	/*
		input : x[96..0]
		output : x[84..12:96..85]
	*/
	void rol12(const Xmm& x, const Xmm& t)
	{
		movdqa(t, x);
		pslldq(x, 1); // x <<= 8
		pslldq(t, 2); // t <<= 16
		psllq(x, 4);
		psrlq(t, 4);
		por(x, t); // t <<= 12
		pxor(t, t);
		movhlps(t, x);
		psrlq(t, 21 + 12); // t = x[..85]
		por(x, t);
	}
	/*
		in : x = [L1:L0], [H1:H0]
		out : x mod (x^97 + x^12 - 1)
	*/
	void reduce(const Xmm& L0, const Xmm& L1, const Xmm& H0, const Xmm& H1, const Xmm& t0, const Xmm& t1, const Xmm& t2)
	{
		static const uint32_t MIE_ALIGN(16) mask0[] = { 0xfff, 0, 0, 0 }; // QQQ
		static const uint32_t MIE_ALIGN(16) mask1[] = { 0xffffffff, 0xffffffff, 0xffffffff, 1, 0 };
		movdqa(t2, ptr [mask0]);
		shr97(L0, L1, t0); // L1 = [L1:L0] >> 97
		shr97(H0, H1, t0); // H1 = [H1:H0] >> 97
		add16(L0, H0, L1, H1, t0, t1);
		rol12(L1, t0);
		rol12(H1, t0);
		sub16(L0, H0, L1, H1, t0, t1);
		pand(L1, t2);
		pand(H1, t2);
		movdqa(t2, ptr [mask1]);
		psllq(L1, 12);
		psllq(H1, 12);
		add16D(L0, H0, L1, H1, t0);
		pand(L0, t2);
		pand(H0, t2);
	}
	/*
		input : x
		destroy : t1, t2
		output : out, x(if pos == 0)
		bit = 2̂Ƃ out = x + ((x >> 1) & 1);
		bit = 3̂Ƃ in[pos + 2:pos + 1:pos]=[b2 b1 b0]9b2 + 3b1 + b0ɕϊ
	*/
	void cvtBinToTri(const Xmm& out, const Xmm& x, const Xmm& t0, const Xmm& t1, const Xmm& mask0, const Xmm& mask1, int bit, int pos)
	{
		if (bit == 1) {
			movdqa(out, x);
			if (pos > 0) {
				psrlq(out, pos);
			}
			pand(out, mask0);
			return;
		}
		const Xmm *t = &x;
		if (pos > 0) {
			movdqa(t0, x);
			psrlq(t0, pos);
			t = &t0;
		}
		switch (bit) {
		case 2:
			pand(*t, mask1);
			movdqa(out, *t);
			psrlq(*t, 1);
			pand(*t, mask0);
			paddd(out, *t);
			break;
		case 3:
			/*
				x = 4a + 2b + c
				y = 9a + 3b + c = 8a + a + (2b + c) + b
			*/
			movdqa(out, *t);
			psrlq(out, 2);
			pand(out, mask0); // a
			movdqa(t1, out);
			psllq(t1, 3); // 8a
			paddd(out, t1); // 9a
			movdqa(t1, *t);
			pand(t1, mask1); // 2b + c
			paddd(out, t1); // 9a + 2b + c
			psrlq(t1, 1);
			pand(t1, mask0); // b
			paddd(out, t1);
			break;
		case 4:
			/*
				x = 8a + 4b + 2c + d
				y = 27a + 9b + 3c + d = (3a + b) * 8 + (3a + b) + (2c + d) + c
			*/
			movdqa(out, *t);
			psrlq(out, 2);
			pand(out, mask1); // 2a + b
			movdqa(t1, out);
			psrlq(t1, 1);
			pand(t1, mask0); // a
			paddd(out, t1); // 3a + b
			movdqa(t1, out);
			psllq(t1, 3); // (3a + b) * 8
			paddd(out, t1); // 27a + 9b
			movdqa(t1, *t);
			pand(t1, mask1); // 2c + d
			paddd(out, t1); // 27a + 9b + 2c + d
			psrlq(t1, 1);
			pand(t1, mask0); // c
			paddd(out, t1); // 27a + 9b + 3c + d
			break;
		default:
			fprintf(stderr, "bad bit=%d\n", bit);
			assert(0);
		}
#if 0
		pxor(out, out);
		for (int j = 0; j < bit; j++) {
			movdqa(t0, x);
			int s = pos + bit - 1 - j;
			if (s) {
				psrlq(t0, s);
			}
			pand(t0, mask0);
			paddd(out, t0);
			if (j < bit - 1) {
				movdqa(t0, out);
				paddd(out, t0);
				paddd(out, t0);
			}
		}
#endif
	}
	/*
		setIdx<firstShiftBit, w>(&idxTbl[0][0], b, topBit);
		for (int s = 1, i = topBit - bit; i >= 0; i -= bit, s++) {
			setIdx<bit, w>(&idxTbl[s][0], b, i);
		}
	*/
	void makeIdxTbl(int bit, int w, int firstShiftBit, int topBit, const Reg32& x, const Reg32& idxTbl)
	{
#ifdef QQQ
		const int n = w == 8 ? 0 : w == 16 ? 1 : 2;
		MIE_ALIGN(16) static const uint32_t maskTbl[3][2][4] = {
			{ // w = 8
				{ 0x03030303, 0x03030303, 0x03030303, 0x03030303 },
				{ 0x0C0C0C0C, 0x0C0C0C0C, 0x0C0C0C0C, 0x0C0C0C0C },
			},
			{ // w = 16
				{ 0x00010001, 0x00010001, 0x00010001, 0x00010001 },
			},
			{ // w = 32
				{ 0x00000001, 0x00000001, 0x00000001, 0x00000001 },
			}
		};
		movdqa(xm6, ptr [maskTbl[n][0]]);
		movdqa(xm7, ptr [maskTbl[n][1]]);
		movdqa(xm0, ptr [x]); // L
		movdqa(xm1, ptr [x + 16]); // H
		for (int s = 0, i = topBit; i >= 0; i -= bit, s++) {
			int b = (s == 0) ? firstShiftBit : bit;
			movdqa(xm2, xm0);
			movdqa(xm3, xm1);
			if (i > 0) psrlq(xm2, i);
			if (i > 2) {
				psrlq(xm2, i - 2);
			} else if (i == 0) {
				psllq(xm2, 2);
			}
			pand(xm2, xm6);
			pand(xm3, xm7);
			por(xm2, xm3);
//			cvtBinToTri(xm2, xm0, xm4, xm5, xm6, xm7, b, i);
//			cvtBinToTri(xm3, xm1, xm4, xm5, xm6, xm7, b, i);
//			paddd(xm2, xm3);
//			paddd(xm2, xm3); // L + H * 2
			movdqa(ptr [idxTbl + s * 16], xm2);
		}
#else
		const int n = w == 8 ? 0 : w == 16 ? 1 : 2;
		MIE_ALIGN(16) static const uint32_t maskTbl[3][2][4] = {
			{ // w = 8
				{ 0x01010101, 0x01010101, 0x01010101, 0x01010101 },
				{ 0x03030303, 0x03030303, 0x03030303, 0x03030303 },
			},
			{ // w = 16
				{ 0x00010001, 0x00010001, 0x00010001, 0x00010001 },
				{ 0x00030003, 0x00030003, 0x00030003, 0x00030003 },
			},
			{ // w = 32
				{ 0x00000001, 0x00000001, 0x00000001, 0x00000001 },
				{ 0x00000003, 0x00000003, 0x00000003, 0x00000003 },
			}
		};
		movdqa(xm6, ptr [maskTbl[n][0]]);
		movdqa(xm7, ptr [maskTbl[n][1]]);
		movdqa(xm0, ptr [x]); // L
		movdqa(xm1, ptr [x + 16]); // H
		for (int s = 0, i = topBit; i >= 0; i -= bit, s++) {
			int b = (s == 0) ? firstShiftBit : bit;
			cvtBinToTri(xm2, xm0, xm4, xm5, xm6, xm7, b, i);
			cvtBinToTri(xm3, xm1, xm4, xm5, xm6, xm7, b, i);
			paddd(xm2, xm3);
			paddd(xm2, xm3); // L + H * 2
			movdqa(ptr [idxTbl + s * 16], xm2);
		}
#endif
	}
	/*
		use all xmm0, ..., xm7
		input : in ; address of [H:L], tbl = MIE_ETAT::cubeTbl
		output : (in + offset)[H:L] = cube(in[H:L])

		96 : [95..64]                 : [63..32]      : [31..0]
		---

		32 : [96..65]                 : [64..33]      : [31..0]                  ; a
		-- : [92..61]                 : [60..33] << 4 : [96..89] << 4 | [92..89] ; b
		-- : [88..61] << 4 | [64..61] : [60..33] << 4 : [96..89] << 4 | [96..93] ; c
	*/
	void cubeCore(const Reg32& in, int offset, const Reg32& tbl, const Reg32& t0, const Reg32& t1)
	{
		movdqa(xm0, ptr [in]); // L
		movdqa(xm1, ptr [in + 16]); // H
		MIE_ALIGN(16) static const uint32_t m[][4] = {
			{ 0x00000000, 0x00000000, 0x00000ff0, 0x00000000 }, // 0
			{ 0xfffffff0, 0x0000000f, 0x00000000, 0x00000000 }, // 2
			{ 0x00000000, 0x00000000, 0x00000000, 0x00000001 }, // 3
		};
		movdqa(xm6, xm0);
		movdqa(xm7, xm1);
		shr128(xm0, xm4, 33); // [-:-:96..65:64..33]
		shr128(xm1, xm4, 33);
		movlhps(xm0, xm6); // [*:31..0:96..65:64..33]
		movlhps(xm1, xm7);
		pxor(xm4, xm4);
		pxor(xm5, xm5);
		movss(xm4, xm0); // [-:-:-:64..33]
		movss(xm5, xm1);
		psllq(xm4, 4); // [-:-:_64..61:60..33____]
		psllq(xm5, 4);

		psrlq(xm6, 21); // [-:_96..89????:*:*]
		psrlq(xm7, 21);
		pand(xm6, ptr [m[0]]); // -:_96..89____:-:-]
		pand(xm7, ptr [m[0]]);
		por(xm4, xm6); // [-:_96..89____:__64..61:60..33____]
		por(xm5, xm7);
		movdqa(xm6, xm0);
		movdqa(xm7, xm1);
		psrlq(xm6, 28); // [*:*:*96..93:92..65????]
		psrlq(xm7, 28);
		pand(xm6, ptr [m[1]]); // [-:-:__96..93:92..65____]
		pand(xm7, ptr [m[1]]);
		pslldq(xm6, 4);
		pslldq(xm7, 4);
		por(xm6, xm5); // [96..65] - ([96..89] + ([64..33] << 4))
		por(xm7, xm4);
		movdqa(xm2, xm0);
		movdqa(xm3, xm1);
		add16D(xm0, xm1, xm6, xm7, xm4);
		psrlq(xm2, 24); // [*:*:92..89:88..61????]
		psrlq(xm3, 24);
		pand(xm2, ptr [m[1]]);
		pand(xm3, ptr [m[1]]);
		pslldq(xm2, 4); // [-:_92..89:88..61____:-]
		pslldq(xm3, 4);
		add16D(xm0, xm1, xm2, xm3, xm4);

		movd(t0, xm0);
		expand(xm2, t0, tbl, xm6, t1, 2);
		movd(t0, xm1);
		expand(xm3, t0, tbl, xm6, t1, 2);

		psrldq(xm0, 4);
		psrldq(xm1, 4);
		movd(t0, xm0);
		expand(xm4, t0, tbl, xm6, t1, 1);
		movd(t0, xm1);
		expand(xm5, t0, tbl, xm6, t1, 1);

		por(xm2, xm4);
		por(xm3, xm5);
		psrldq(xm0, 4);
		psrldq(xm1, 4);
		movd(t0, xm0);
		expand(xm0, t0, tbl, xm6, t1, 0);
		movd(t0, xm1);
		expand(xm1, t0, tbl, xm6, t1, 0);
		por(xm0, xm2);
		por(xm1, xm3);

		movdqa(xm2, ptr [in]);
		movdqa(xm3, ptr [in + 16]);
		pslldq(xm2, 8);
		pslldq(xm3, 8);
		pand(xm2, ptr [m[2]]);
		pand(xm3, ptr [m[2]]);
		por(xm0, xm2);
		por(xm1, xm3);

		movdqa(ptr [in + offset], xm0);
		movdqa(ptr [in + offset + 16], xm1);
	}
};

class OptimizedMulLatter {
	enum {
		BIT_KIND_NUM = 3, /* 2, 3, 4 */
		W_KIND_NUM = 3 /* 8, 16, 32 */
	};
	GeneratorForF3_97 codeTbl[BIT_KIND_NUM][W_KIND_NUM];
	F3_97::mulLatterFunc funcTbl[BIT_KIND_NUM][W_KIND_NUM];
public:
	OptimizedMulLatter()
	{
		static const int bitTbl[] = { 2, 3, 4 };
		static const int wTbl[] = { 8, 16, 32 };
		for (size_t i = 0; i < mie::NumOfArray(bitTbl); i++) {
			int bit = bitTbl[i];
			for (size_t j = 0; j < mie::NumOfArray(wTbl); j++) {
				int w = wTbl[j];
				codeTbl[i][j].createOptimizedMulLatter(bit, w);
				funcTbl[i][j] = (F3_97::mulLatterFunc)(codeTbl[i][j].getCode());
			}
		}
	}
	template<int bit, int w>
	inline void (*get() const)(F3_97& out, const F3_97 *xTbl, const F3_97& b)
	{
		return funcTbl[bit - 2][w == 32 ? 2 : w == 16 ? 1 : 0];
	}
};

class OptimizedMakePrevMulTbl {
	enum {
		BIT_KIND_NUM = 3 /* 2, 3, 4 */
	};
	GeneratorForF3_97 codeTbl[BIT_KIND_NUM];
	F3_97::makePrevMulTblFunc funcTbl[BIT_KIND_NUM];
public:
	OptimizedMakePrevMulTbl()
	{
		static const int bitTbl[] = { 2, 3, 4 };
		for (size_t i = 0; i < mie::NumOfArray(bitTbl); i++) {
			int bit = bitTbl[i];
			codeTbl[i].createOptimizedMakePrevMulTbl(bit);
			funcTbl[i] = (F3_97::makePrevMulTblFunc)(codeTbl[i].getCode());
		}
	}
	template<int bit>
	inline void (*get() const)(F3_97 *xTbl, const F3_97& x)
	{
		return funcTbl[bit - 2];
	}
};

class OptimizedCube {
	GeneratorForF3_97 code;
	F3_97::cubeFunc func;
public:
	OptimizedCube()
	{
		code.createOptimizedCube();
		func = (F3_97::cubeFunc)code.getCode();
	}
	inline void (*get() const)(F3_97& x)
	{
		return func;
	}
};

class OptimizedRawShl {
	enum {
		TYPE_NUM = 3 /* 0:any, 1:fix, 2:fix */
	};
	GeneratorForF3_97 codeTbl[TYPE_NUM];
	F3_97::rawShlFunc func[TYPE_NUM];
public:
	OptimizedRawShl()
	{
		for (int type = 0; type < TYPE_NUM; type++) {
			codeTbl[type].createOptimizedRawShl(type);
			func[type] = (F3_97::rawShlFunc)codeTbl[type].getCode();
		}
	}
	inline void (*get() const)(F3_97& x, int bit)
	{
		return func[0];
	}
#if 0
	inline void (*get1() const)(uint32_t *)
	{
		return (uint32_t (*)(uint32_t*))func[1];
	}
	inline void (*get2() const)(uint32_t *)
	{
		return (uint32_t (*)(uint32_t*))func[2];
	}
#endif
};

class OptimizedDegree {
	GeneratorForF3_97 codeTbl;
	F3_97::degreeFunc func;
public:
	OptimizedDegree()
	{
		codeTbl.createOptimizedDegree();
		func = (F3_97::degreeFunc)codeTbl.getCode();
	}
	inline int (*get() const)(const F3_97&)
	{
		return func;
	}
};

class OptimizedCubeSeq {
	GeneratorForF3_97 codeTbl;
	F3_97::cubeSeqFunc func;
public:
	OptimizedCubeSeq()
	{
		codeTbl.createOptimizedCubeSeq();
		func = (F3_97::cubeSeqFunc)codeTbl.getCode();
	}
	inline void (*get() const)(F3_97*)
	{
		return func;
	}
};

#endif
