#ifndef MIE_UTIL_H_
#define MIE_UTIL_H_
/**
	@file mie_util.h
	@brief 悭g֐Q
	@author $Author: shigeo $
	@version $Revision: 1.26 $
	@date $Date: 2010/04/26 05:29:16 $
*/
#include "mie_common.h"
#include <stdlib.h> /* for atoi */
#include <string.h> /* for strcmp */
#include <string>

#ifdef _MSC_VER
#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")
#include <tchar.h>
#include <mbctype.h>
#endif

namespace mie {

#ifndef _MSC_VER
	#ifndef _TCHAR
		#if defined(UNICODE) || defined(_UNICODE)
			#define _TCHAR wchar_t
			#define _T(x) x
		#else
			#define _TCHAR char
			#define _T(x) L##x
		#endif
	#endif
#endif
typedef std::basic_string<_TCHAR> Tstring;

namespace Util {

/**
	32bitlittle endianƂăɊi[
	@param src [in] 32bit
	@param dest [out] ւ̃|C^
*/
static inline void set32bitAsLE(uint32_t src, void *dest)
{
	uint8_t *p = reinterpret_cast<uint8_t*>(dest);
	p[0] = uint8_t(src);
	p[1] = uint8_t(src >> 8);
	p[2] = uint8_t(src >> 16);
	p[3] = uint8_t(src >> 24);
}

/**
	32bitbig endianƂăɊi[
	@param src [in] 32bit
	@param dest [out] ւ̃|C^
*/
static inline void set32bitAsBE(uint32_t src, void *dest)
{
	uint8_t *p = reinterpret_cast<uint8_t*>(dest);
	p[0] = uint8_t(src >> 24);
	p[1] = uint8_t(src >> 16);
	p[2] = uint8_t(src >> 8);
	p[3] = uint8_t(src);
}

/**
	little endianƂ32bitǂݍ
	@param src [in] ւ̃|C^
*/
static inline uint32_t get32bitAsLE(const void *src)
{
	const uint8_t *p = reinterpret_cast<const uint8_t*>(src);
	return p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24);
}

/**
	big endianƂ32bitǂݍ
	@param src [in] ւ̃|C^
*/
static inline uint32_t get32bitAsBE(const void *src)
{
	const uint8_t *p = reinterpret_cast<const uint8_t*>(src);
	return p[3] | (p[2] << 8) | (p[1] << 16) | (p[0] << 24);
}

/**
	16bitlittle endianƂăɊi[
	@param src [in] 16bit
	@param dest [out] ւ̃|C^
*/
static inline void set16bitAsLE(uint32_t src, void *dest)
{
	uint8_t *p = reinterpret_cast<uint8_t*>(dest);
	p[0] = uint8_t(src);
	p[1] = uint8_t(src >> 8);
}

/**
	16bitbig endianƂăɊi[
	@param src [in] 16bit
	@param dest [out] ւ̃|C^
*/
static inline void set16bitAsBE(uint32_t src, void *dest)
{
	uint8_t *p = reinterpret_cast<uint8_t*>(dest);
	p[0] = uint8_t(src >> 8);
	p[1] = uint8_t(src);
}

/**
	little endianƂ16bitǂݍ
	@param src [in] ւ̃|C^
*/
static inline uint64_t get16bitAsLE(const void *src)
{
	const uint8_t *p = reinterpret_cast<const uint8_t*>(src);
	return uint64_t(p[0] | (p[1] << 8));
}

/**
	big endianƂ16bitǂݍ
	@param src [in] ւ̃|C^
*/
static inline uint64_t get16bitAsBE(const void *src)
{
	const uint8_t *p = reinterpret_cast<const uint8_t*>(src);
	return uint64_t(p[1] | (p[0] << 8));
}

/** stringwstringւ̕ϊ */
static inline std::string ConvertToChar(const std::wstring& str)
{
#ifdef _WIN32
	char buf[1024];
	int len;
	BOOL used;
	len = WideCharToMultiByte(_KANJI_CP, WC_COMPOSITECHECK | WC_SEPCHARS,
		str.c_str(), -1, buf, sizeof(buf), 0, &used);
	if (len > 0 && !used) {
		return buf;
	}
	return "";
#else
//	#error "not implemented ConvertToChar"
	fprintf(stderr, "not implemented ConvertToChar(%S)\n", str.c_str());
	exit(1);
#endif
}

/** wstringstringւ̕ϊ */
static inline std::wstring ConvertToWChar(const std::string& str)
{
#ifdef _WIN32
	wchar_t buf[1024];
	int ret;
	ret = MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, buf, sizeof(buf));
	if (ret > 0) {
		return std::wstring(buf, ret);
	}
	return L"";
#else
//	#error "not implemented ConvertToWChar"
	fprintf(stderr, "not implemented ConvertToWChar(%s)\n", str.c_str());
	exit(1);
#endif
}

static inline std::string GetExecPathA()
{
#if defined(_MSC_VER)
	char path[MAX_PATH];
	if (GetModuleFileNameA(NULL, path, sizeof(path))) {
		if (PathRemoveFileSpecA(path)) {
			PathAddBackslashA(path);
			return path;
		}
	}
	return "";
#elif defined(__linux__)
	char path[4096];
	int ret = readlink("/proc/self/exe", path, sizeof(path));
	if (ret != -1) {
		std::string chop(path, ret);
		int pos = chop.find_last_of('/');
		if (pos > 0) {
			return chop.substr(0, pos + 1).c_str();
		}
	}
	return "";
#else
#error "implement GetExecPathA"
#endif
}

/**
	͊NX
	ƓK
	@note g

	bool analyze(int argc, const char *const argv[])
	{
		set(argc, argv);

		while (hasOption()) {
			if (isMatch("-width", 1)) {
				width_ = getInteger();
			} else
			if (isMatch("-tcp", 0)) {
				isTCP_ = true;
			} else
			{
				usage();
				return false;
			}
			next();
		}
		...
	}
*/
class OptionBase {
private:
	int argc_;
	const char *const* argv_;

protected:
	virtual void usage() = 0;

	inline void next()
	{
		argc_--, argv_++;
	}
	inline const char *querryNextString() const
	{
		if (argc_ > 1) {
			return argv_[1];
		} else {
			return 0;
		}
	}
	inline int getArgc() const { return argc_; }
	inline bool hasOption() const
	{
		return argc_ > 0;
	}
	/**
		IvVɃ}b`
		@param option [in] ׂIvV(:"-width")
		@param optNum [in] IvVƂ̐
		@note optNum > 0 ̂Ƃ͊enext()(optNum - 1)ĂԂ
	*/
	inline bool isMatch(const char *option, int optNum = 0)
	{
		if (argc_ > optNum && strcmp(*argv_, option) == 0) {
			if (optNum > 0) {
				next();
			}
			return true;
		}
		return false;
	}
	inline const char *getString() const { return *argv_; }
	inline int getInteger() const { return atoi(*argv_); }

	void set(int argc, const char *const* argv)
	{
		argc_ = argc;
		argv_ = argv;
		next();
	}

public:
	OptionBase()
		: argc_(0)
		, argv_(0)
	{
	}
};

} // end of namespace

} // end of namespace

#endif /* MIE_UTIL_H_ */

